import { Lazy } from '../../../common/lazy.js';
const nullHoverDelegateFactory = () => ({
    get delay() { return -1; },
    dispose: () => { },
    showHover: () => { return undefined; },
});
let hoverDelegateFactory = nullHoverDelegateFactory;
const defaultHoverDelegateMouse = ( new Lazy(() => hoverDelegateFactory('mouse', false)));
const defaultHoverDelegateElement = ( new Lazy(() => hoverDelegateFactory('element', false)));
function setHoverDelegateFactory(hoverDelegateProvider) {
    hoverDelegateFactory = hoverDelegateProvider;
}
function getDefaultHoverDelegate(placement, enableInstantHover) {
    if (enableInstantHover) {
        return hoverDelegateFactory(placement, true);
    }
    if (placement === 'element') {
        return defaultHoverDelegateElement.value;
    }
    return defaultHoverDelegateMouse.value;
}
export { getDefaultHoverDelegate, setHoverDelegateFactory };
