import { CharacterClassifier } from './characterClassifier.js';
class WordCharacterClassifier extends CharacterClassifier {
    constructor(wordSeparators) {
        super(0 );
        for (let i = 0, len = wordSeparators.length; i < len; i++) {
            this.set(wordSeparators.charCodeAt(i), 2 );
        }
        this.set(32 , 1 );
        this.set(9 , 1 );
    }
}
function once(computeFn) {
    const cache = {};
    return (input) => {
        if (!cache.hasOwnProperty(input)) {
            cache[input] = computeFn(input);
        }
        return cache[input];
    };
}
const getMapForWordSeparators = once((input) => ( new WordCharacterClassifier(input)));
export { WordCharacterClassifier, getMapForWordSeparators };
